/****************************************************
 *Parasite Removing Armory Plugin                   *
 *<andy@resourcecode.de>                            *
 *--------------------------------------------------*
 *Under GPL (like Metamod)                          *
 ****************************************************/

#include <extdll.h>
#include <dllapi.h>
#include <meta_api.h>
#include <cbase.h>
#include <player.h>
#include "pra.h"

float			NextEntityCheck = 0, NextInfectedCheck = 0;
playerinfo_t	PlayerInfo[1024];
DLL_GLOBAL const Vector     g_vecZero = Vector(0,0,0);

// Thx to voogru for "Armory-USE" code
int Spawn( edict_t *pent )
{
	if(FStrEq(STRING(pent->v.classname), "worldspawn"))
	{
		NextEntityCheck = 0;
		RETURN_META_VALUE(MRES_HANDLED,0);
	}
	if(FStrEq(STRING(pent->v.classname), "player"))
	{
		PlayerInfo[ENTINDEX(pent)].UsingPR = false;
		PlayerInfo[ENTINDEX(pent)].PercentClomplete = 0;
	}
	RETURN_META_VALUE(MRES_IGNORED, 0);
}

BOOL ClientConnect( edict_t *pEntity, const char *pszName, const char *pszAddress, char szRejectReason[128]  )
{
	PlayerInfo[ENTINDEX(pEntity)].UsingPR = FALSE;
	PlayerInfo[ENTINDEX(pEntity)].PercentClomplete = 0;

	CLIENT_PRINTF( pEntity, print_console, "\n");
	CLIENT_PRINTF( pEntity, print_console, "Parasite Removing Armory Plugin version 2.1 - 2003/11/20");
	CLIENT_PRINTF( pEntity, print_console, "\n");
	CLIENT_PRINTF( pEntity, print_console,"By: Andy / Andrew Karpow\n");

	RETURN_META_VALUE(MRES_HANDLED, true);
}

void StartFrame(void)
{
	if(NextEntityCheck < gpGlobals->time)
	{

		if(NextInfectedCheck < gpGlobals->time)
		{
			CBaseEntity *pCPlayer = NULL;
			while(pCPlayer = UTIL_FindEntityByClassname(pCPlayer, "player"))
			{	
				edict_t *pPlayer;
				pPlayer = pCPlayer->edict();
				
				if(!UTIL_IsMarine(pPlayer) || !(pPlayer->v.iuser4 & MASK_PARASITED))
					continue;

				char temp[160];
				sprintf(temp, " -| parasite removing armory plugin |-  You have been infected, press and hold the \"use\" key in front of an%s armory to remove the parasite.", (CVAR_GET_FLOAT("nsmm_advarm") ? " advanced" : "") );
				UTIL_NSPopupmsg(pPlayer, temp);
			}
			NextInfectedCheck = gpGlobals->time + 20.0;
		}

		CBaseEntity *pArmory = NULL;
		if(!CVAR_GET_FLOAT("nsmm_advarm"))
		{
			while(pArmory = UTIL_FindEntityByClassname(pArmory, "team_armory"))
			{
				if(!pArmory->pev->nextthink)
				{
					pArmory->pev->nextthink = gpGlobals->time + (CVAR_GET_FLOAT("nsmm_timedelay") / 10.0);
				}
			}
		}

		while(pArmory = UTIL_FindEntityByClassname(pArmory, "team_advarmory"))
		{
			if(!pArmory->pev->nextthink)
			{
				pArmory->pev->nextthink = gpGlobals->time + (CVAR_GET_FLOAT("nsmm_timedelay") / 10.0);
			}
		}
		NextEntityCheck = gpGlobals->time + 0.25;
	}
	RETURN_META(MRES_IGNORED);
}


void Think( edict_t *pent )
{
	if(FStrEq(STRING(pent->v.classname), "team_advarmory") || (CVAR_GET_FLOAT("nsmm_advarm") ? 0 : FStrEq(STRING(pent->v.classname), "team_armory")))
	{
		ParasiteRemover(pent);
		RETURN_META(MRES_HANDLED);
	}
	RETURN_META(MRES_IGNORED);
}

/*
// ===== DEBUG =====
void ClientCommand( edict_t *pEntity ) {
	if( !strcmp(CMD_ARGV(0), "parasite") )
	{
		if(!(pEntity->v.iuser4 & MASK_PARASITED))
			pEntity->v.iuser4 |= MASK_PARASITED;
		RETURN_META(MRES_SUPERCEDE);
	}

	if( !strcmp(CMD_ARGV(0), "pstart") )
	{
		UTIL_StartProgress(pEntity, ENTINDEX(pEntity));

		RETURN_META(MRES_SUPERCEDE);
	}

	if( !strcmp(CMD_ARGV(0), "pstop") )
	{
		UTIL_EndProgress(pEntity);
		RETURN_META(MRES_SUPERCEDE);
	}
	RETURN_META(MRES_IGNORED);
}
*/

void ParasiteRemover(edict_t *pParasiteRemover)
{
	if( !UTIL_IsBuilt(pParasiteRemover) )
		return;

	CBaseEntity *pCPlayer = NULL;
	while(pCPlayer = UTIL_FindEntityByClassname(pCPlayer, "player"))
	{
		edict_t *pPlayer;
		pPlayer = pCPlayer->edict();
		
		if((pCPlayer->pev->origin - pParasiteRemover->v.origin).LengthSquared() < (5184))
		{
			if((pCPlayer->pev->team == pParasiteRemover->v.team) && ((pCPlayer->pev->button & IN_USE) > 0) && IsAlive(pPlayer))
			{
				if( ( pCPlayer->pev->iuser4 & MASK_PARASITED ) > 0 )
				{
					if(PlayerInfo[ENTINDEX(pPlayer)].UsingPR && ( PlayerInfo[ENTINDEX(pPlayer)].PercentClomplete < 100 ))
					{
						pPlayer->v.fuser3 = PlayerInfo[ENTINDEX(pPlayer)].PercentClomplete * 10.0;
						PlayerInfo[ENTINDEX(pPlayer)].PercentClomplete += 10;

						char blub[30];
						sprintf(blub, "Removing parasite... %d%%%%", PlayerInfo[ENTINDEX(pPlayer)].PercentClomplete);
						UTIL_ClientPrint( pPlayer, HUD_PRINTCENTER, blub );
					}
					else if(!PlayerInfo[ENTINDEX(pPlayer)].UsingPR)
					{
						PlayerInfo[ENTINDEX(pPlayer)].UsingPR = true;
						PlayerInfo[ENTINDEX(pPlayer)].PercentClomplete = 10;
						
						UTIL_StartProgress(pPlayer, ENTINDEX(pPlayer));
						pPlayer->v.fuser3 = 0.0;

						UTIL_ClientPrint( pPlayer, HUD_PRINTCENTER, "Removing parasite... 10%%." );
					}
					else if(PlayerInfo[ENTINDEX(pPlayer)].PercentClomplete == 100)
					{
						pPlayer->v.fuser3 = 1000.0;
						pPlayer->v.iuser4 -= MASK_PARASITED;
						PlayerInfo[ENTINDEX(pPlayer)].UsingPR = false;
						PlayerInfo[ENTINDEX(pPlayer)].PercentClomplete = 0;

						UTIL_EndProgress(pPlayer);
						PLAYBACK_EVENT_FULL( 0, pPlayer, 40, 0, pCPlayer->pev->origin, (float *)&g_vecZero, 0.0, 0.0, 0, 0, 0, 0 );
						EMIT_SOUND_DYN(pPlayer, CHAN_ITEM, "misc/phasein.wav", 1, ATTN_NORM, 0, PITCH_NORM);
						UTIL_ClientPrint( pPlayer, HUD_PRINTCENTER, "Parasite has been removed!" );
					}
				}
			}
			else
			{
				PlayerInfo[ENTINDEX(pPlayer)].UsingPR = FALSE;
				PlayerInfo[ENTINDEX(pPlayer)].PercentClomplete = 0;
				UTIL_EndProgress(pPlayer);
			}
		}
		else
		{
			if( PlayerInfo[ENTINDEX(pPlayer)].PercentClomplete )
			{
				PlayerInfo[ENTINDEX(pPlayer)].PercentClomplete = 0;
				UTIL_EndProgress(pPlayer);
				PlayerInfo[ENTINDEX(pPlayer)].UsingPR = FALSE;
			}
		}
	}
	return;
}

static DLL_FUNCTIONS gFunctionTable = 
{
	NULL, // pfnGameInit
	Spawn, // pfnSpawn
	Think, // pfnThink
	NULL, // pfnUse
	NULL, // pfnTouch
	NULL, // pfnBlocked
	NULL, // pfnKeyValue
	NULL, // pfnSave
	NULL, // pfnRestore
	NULL, // pfnSetAbsBox

	NULL, // pfnSaveWriteFields
	NULL, // pfnSaveReadFields

	NULL, // pfnSaveGlobalState
	NULL, // pfnRestoreGlobalState
	NULL, // pfnResetGlobalState

	ClientConnect, // pfnClientConnect
	NULL, // pfnClientDisconnect
	NULL, // pfnClientKill
	NULL, // pfnClientPutInServer
	NULL/*ClientCommand*/, // pfnClientCommand
	NULL, // pfnClientUserInfoChanged
	NULL, // pfnServerActivate
	NULL, // pfnServerDeactivate

	NULL, // pfnPlayerPreThink
	NULL, // pfnPlayerPostThink

	StartFrame, // pfnStartFrame
	NULL, // pfnParmsNewLevel
	NULL, // pfnParmsChangeLevel

	NULL, // pfnGetGameDescription
	NULL, // pfnPlayerCustomization

	NULL, // pfnSpectatorConnect
	NULL, // pfnSpectatorDisconnect
	NULL, // pfnSpectatorThink

	NULL, // pfnSys_Error

	NULL, // pfnPM_Move
	NULL, // pfnPM_Init
	NULL, // pfnPM_FindTextureType

	NULL, // pfnSetupVisibility
	NULL, // pfnUpdateClientData
	NULL, // pfnAddToFullPack
	NULL, // pfnCreateBaseline
	NULL, // pfnRegisterEncoders
	NULL, // pfnGetWeaponData
	NULL, // pfnCmdStart
	NULL, // pfnCmdEnd
	NULL, // pfnConnectionlessPacket
	NULL, // pfnGetHullBounds
	NULL, // pfnCreateInstancedBaselines
	NULL, // pfnInconsistentFile
	NULL, // pfnAllowLagCompensation
};

C_DLLEXPORT int GetEntityAPI2(DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion)
{
	if(!pFunctionTable)
	{
		UTIL_LogPrintf("GetEntityAPI2 called with null pFunctionTable\n");
		return(FALSE);
	}
	else if (*interfaceVersion != INTERFACE_VERSION)
	{
		UTIL_LogPrintf("GetEntityAPI2 version mismatch; requested=%d ours=%d\n",
		 *interfaceVersion, INTERFACE_VERSION);
		*interfaceVersion = INTERFACE_VERSION;
		return(FALSE);
	}

	memcpy(pFunctionTable, &gFunctionTable, sizeof(DLL_FUNCTIONS));
	return(TRUE);
}
