
#include <meta_api.h>
typedef struct playerinfo_s
{
	bool UsingPR;
	int PercentClomplete;
} playerinfo_t;

typedef enum
{
	PLAYERCLASS_NONE = 0,
	PLAYERCLASS_ALIVE_MARINE,
	PLAYERCLASS_ALIVE_HEAVY_MARINE,
	PLAYERCLASS_ALIVE_LEVEL1,
	PLAYERCLASS_ALIVE_LEVEL2,
	PLAYERCLASS_ALIVE_LEVEL3,
	PLAYERCLASS_ALIVE_LEVEL4,
	PLAYERCLASS_ALIVE_LEVEL5,
	PLAYERCLASS_ALIVE_DIGESTING,
	PLAYERCLASS_ALIVE_GESTATING,
	PLAYERCLASS_DEAD_MARINE,
	PLAYERCLASS_DEAD_ALIEN,
	PLAYERCLASS_COMMANDER,
	PLAYERCLASS_REINFORCING,
	PLAYERCLASS_SPECTATOR
} AvHPlayerClass;

#define MASK_PARASITED (1 << 30)
#define MASK_DIGESTING 4194304			// When set on a visible player, player is digesting.  When set on invisible player, player is being digested
#define	MASK_ALIEN_EMBRYO 268435456

CBaseEntity *UTIL_FindEntityByClassname( CBaseEntity *pStartEntity, const char *szName );
CBaseEntity *UTIL_FindEntityByString( CBaseEntity *pStartEntity, const char *szKeyword, const char *szValue );
void ParasiteRemover(edict_t *pParasiteRemover);
bool IsAlive(edict_t *pEdict);
void UTIL_ClientPrint( edict_t *pEntity, int msg_dest, const char *msg_name);
bool UTIL_IsBuilt(edict_t *pent);
bool UTIL_IsMarine(edict_t *pEdict);
void UTIL_NSPopupmsg( edict_t *pEntity, const char *msg_name);
void UTIL_EndProgress(edict_t *pEntity);
void UTIL_StartProgress(edict_t *pEntity, int dest);
void EMIT_SOUND_DYN(edict_t *entity, int channel, const char *sample, float volume, float attenuation, int flags, int pitch);