#include <extdll.h>
#include <enginecallback.h>     // ALERT()
#include "osdep.h"              // win32 vsnprintf, etc
#include <cbase.h>
#include "pra.h"

// Selected portions of dlls/util.cpp from SDK 2.1.
// Functions copied from there as needed...
// And modified to avoid buffer overflows (argh).

//=========================================================
// UTIL_LogPrintf - Prints a logged message to console.
// Preceded by LOG: ( timestamp ) < message >
//=========================================================
void UTIL_LogPrintf( char *fmt, ... )
{
  va_list argptr;
  static char string[1024];

  va_start(argptr, fmt);
  vsnprintf(string, sizeof(string), fmt, argptr);
  va_end(argptr);

  // Print to server console
  ALERT(at_logged, "%s", string);
}

void UTIL_StartProgress(edict_t *pEntity, int dest)
{
   MESSAGE_BEGIN( MSG_ONE_UNRELIABLE, REG_USER_MSG( "Progress", -1 ), NULL, pEntity );
   WRITE_SHORT(dest);
   WRITE_BYTE(3);
   MESSAGE_END();
}

void UTIL_EndProgress(edict_t *pEntity)
{
   MESSAGE_BEGIN( MSG_ONE_UNRELIABLE, REG_USER_MSG( "Progress", -1 ), NULL, pEntity );
   WRITE_SHORT(-1);
   WRITE_BYTE(-1);
   MESSAGE_END();
}

void UTIL_ClientPrint( edict_t *pEntity, int msg_dest, const char *msg_name)
{
   MESSAGE_BEGIN( MSG_ONE, REG_USER_MSG( "TextMsg", -1 ), NULL, pEntity );
   WRITE_BYTE( msg_dest );
   WRITE_STRING( msg_name );
   MESSAGE_END();
}

void UTIL_NSPopupmsg( edict_t *pEntity, const char *msg_name)
{
   MESSAGE_BEGIN( MSG_ONE, REG_USER_MSG( "HudText2", -1 ), NULL, pEntity );
   WRITE_STRING( msg_name );
   WRITE_BYTE(0);
   MESSAGE_END();
}

bool UTIL_IsMarine(edict_t *pEdict)
{
	if(pEdict->v.iuser3 == PLAYERCLASS_ALIVE_MARINE || pEdict->v.iuser3 == PLAYERCLASS_ALIVE_HEAVY_MARINE || pEdict->v.iuser3 == PLAYERCLASS_COMMANDER)
		return TRUE;
	else
		return FALSE;
}

CBaseEntity *UTIL_FindEntityByClassname( CBaseEntity *pStartEntity, const char *szName )
{
  return UTIL_FindEntityByString( pStartEntity, "classname", szName );
}

CBaseEntity *UTIL_FindEntityByString( CBaseEntity *pStartEntity, const char *szKeyword, const char *szValue )
{
  edict_t *pentEntity;

  if (pStartEntity)
   pentEntity = pStartEntity->edict();
  else
   pentEntity = NULL;

  pentEntity = FIND_ENTITY_BY_STRING( pentEntity, szKeyword, szValue );

  if (!FNullEnt(pentEntity))
   return CBaseEntity::Instance(pentEntity);
  return NULL;
}

bool IsAlive(edict_t *pEdict)
{
   return ((pEdict->v.deadflag == DEAD_NO) &&
           (pEdict->v.health > 0) && !(pEdict->v.flags & FL_NOTARGET));
}

//Thx to voogru
bool UTIL_IsBuilt(edict_t *pent)
{
	if( ! (pent->v.iuser4 & (1<<2)) )
	{
		return true;
	}
	else if(FStrEq(STRING(pent->v.classname),"team_hive") && pent->v.fuser1 >= 1000)//Hives are just wierd.
	{
		pent->v.iuser4 &= ~(1<<2);
		return true;
	}
	return false;
}

void EMIT_SOUND_DYN(edict_t *entity, int channel, const char *sample, float volume, float attenuation, int flags, int pitch)
{
	EMIT_SOUND_DYN2(entity, channel, sample, volume, attenuation, flags, pitch);
}